<?
if ( $PHPSHELL )
GUIFactory::setMainGUI("shell");
else
GUIFactory::setMainGUI("dialog");
//                            
/*                                    
                          /    /     /             
                                             *          *  
//                                      
                                                                                                     
                                    //                                
*/
if ( !$configfile ) die ( "You need to specify &configfile=config.php" );
require_once($FILEPATH."/".$MODULE."/fileimport/".$configfile );

file_import_fetch_dir( $file_import_start_dir, $file_import_start_folder_id, $file_import_csv_file, $file_import_csv_format, $file_import_casesensitive );


function file_import_fetch_dir($dir, $folder_id, $csv_file, $csv_format, $casesensitive = false) {
global $FEATURE;
$csv_data = Array();	
$filenames = Array();
if ($d = @opendir($dir)) {
while (($file = readdir($d)) !== false ) {
if ($file == ".." || $file == ".") continue;
set_time_limit( 0 );
decho( "<br>analysing $file.", 'echo' );
if (is_dir("$dir/$file") && $file != ".." && $file != ".") {
decho( "Create a new folder $file.", 'echo' );
$new_folder_id = folder_getid ( $file, $folder_id );
if ( !$new_folder_id ) {
$dir_info = get_folderinfo($folder_id);
$new_folder_id = cmd_folder_create( $file, $folder_id, $dir_info['pub_dir'].$file, '');
if ( !$new_folder_id ) {
die('Error creating folder!!!');
}
decho( "New folder_id is $new_folder_id.", 'echo' );
} else {
decho( "Found existing folder. Id is $new_folder_id.", 'echo' );
}
file_import_fetch_dir("$dir/$file", $new_folder_id, $csv_file, $csv_format);
} else {
if ( ereg( $csv_file, $file) ) {
decho ( "Read csv file $file.", 'echo' );
$csv = new csv();
$csv->init_from_file("$dir/$file");
$csv->setDelimiter(';');
$csv->setEnclosure('"');
$csv->parse_csv();
$csv_data = $csv->getCSV();
//                      /         
 if ( $csv_data === false ) {
decho ("<font color=red>Could not read $dir/$file.", 'echo');
}
} else {
decho ( "Importing file $file.", 'echo');
$fp = @fopen("$dir/$file", "r");
if ($fp ) {
$data = fread ($fp, 10000000);
fclose ($fp);
$type = get_file_content_type("$dir/$file");
$size = strlen($data);
$file_id = cmd_file_create($file, $folder_id, '');
decho( "New file_id is $file_id.", 'echo' );
if ($file_id) {
cmd_file_data($file_id, $data, $size, $type);
touch_objprop( CT_FILE, $file_id, 0, 1);
cmd_tagpart_touch( T_OBJTAG, $file_id, CT_FILE);
if ($casesensitive) {
$filenames[$file] = $file_id;
} else {
$filenames[strtolower($file)] = $file_id;
}
decho ( "Inserted file $file with id $file_id.", 'echo');
} else decho ("<font color=red>Could not create file in db.</font>", 'echo');
} else {
decho ("<font color=red>Could not fetch $dir/$file.</font>", 'echo');
}
}
}
}  
closedir($d);
//                   
 $filename_id = 0;
$header = split( ';', $csv_format );
foreach ( $header as $id => $name ) {
if ( $name == 'filename' ) {
$filename_csv_id = $id;
}
}
global $T_TYPE;
$object_keyname = $T_TYPE[CT_FILE]['key'];
$o_m_file = '';
$objprop_files = Array();
foreach ($csv_data as $line=>$prop) {
set_time_limit(30);
//                                  
 if ($casesensitive) {
$filename = $prop[$filename_csv_id];
} else {
$filename = strtolower($prop[$filename_csv_id]);
}
if ( !$filenames[$filename] ) {
$o_m_file .= $filename.' missing File.<br>';
decho( "<br>Ignoring file [$filename].", 'echo');
continue;
}
$objprop_files[$filename] = true;
decho( "<br>Setting properties for [$filename].", 'echo');
foreach ( $header as $id => $name ) {
if ( $name != 'filename' ) {
$tmp_name = array();
$tmp_name = split( '\.', $name);
$i = 0;
if ( $tmp_name[0] == $object_keyname ) $i = 1;
$prop_name = $tmp_name[$i++];
$part_name = $tmp_name[$i++];
$value = trim($prop[$id]);
if ( $FEATURE["UTF8"] ) $value = iconv( "CP1252", "UTF-8", $value );
decho( "  Setting property $object_keyname.$prop_name.$part_name:$value.", 'echo');
$sql = "SELECT value.id FROM objtag, part, value WHERE 
						objtag.obj_type = ".sqlf_tl_num(CT_FILE)." AND
						objtag.obj_id = ".sqlf_tl_num($filenames[$filename])." AND
						objtag.name = '".sqlf_escaped($object_keyname).".".sqlf_escaped($prop_name)."' AND
						value.part_id = part.id AND
						part.keyword = '".sqlf_escaped($part_name)."' AND
						value.objtag_id = objtag.id ";
//                                     
 //                           
 //                              
 $rs = query($sql);//            
 $value_id = $rs['arr'][0]['id'];
if ( $value_id ) {
decho( "Updating value ID $value_id.", 'echo' );
cmd_update_value( $value, 0, 0, 'obj', FALSE, $value_id);
} else {
decho( "<font color=red>No value ID.</font>", 'echo' );
decho( "Failed SQL: $sql", "echo" );
}
}
}
}
//      
 echo '<p>';
$o_suc= '';
$o_m_csv = '';
foreach ( $filenames as $filename=>$ok ) {
if ( $objprop_files[$filename] ) {
$o_succ .= $filename.' ok.<br>';
} else {
$o_m_csv .= $filename.' missing csv Entry.<br>';
}
}
global $file_import_start_dir;
$import_folder = str_replace( $file_import_start_dir, '', $dir );
if ( $o_succ ) echo '<b>Susessfully Imported from folder '.$import_folder.'</b><br>'.$o_succ;
if ( $o_m_csv ) echo '<font color=red><b>Missing CSV entry for files from folder '.$import_folder.'.</b><br>'.$o_m_csv.'</font>';
if ( $o_m_file ) echo '<font color=red><b>Missing Files for CSV entry from folder '.$import_folder.'.</b><br>'.$o_m_file.'</font>';
echo '</p>';

} else {
die("Error opening dir $dir.");
}
}

function get_file_content_type ( $file ) {
$info = pathinfo( $file );
$ext = $info['extension'];
switch($ext) {
case 'hqx':
return 'application/mac-binhex40';

case 'cpt':
return 'application/mac-compactpro';

case 'doc':
return 'application/msword';

case 'bin':
case 'dms':
case 'lha':
case 'lzh':
case 'exe':
case 'class':
case 'so':
case 'dll':
return 'application/octet-stream';

case 'oda':
return 'application/oda';

case 'pdf':
return 'application/pdf';

case 'ai':
case 'eps':
case 'ps':
return 'application/postscript';

case 'smi':
case 'smil':
return 'application/smil';

case 'xls':
return 'application/ms-excel';

case 'ppt':
return 'application/vnd.ms-powerpoint';

case 'wbxml':
return 'application/vnd.wap.wbxml';

case 'wmlc':
return 'application/vnd.wap.wmlc';

case 'wmlsc':
return 'application/vnd.wap.wmlscriptc';

case 'bcpio':
return 'application/x-bcpio';

case 'vcd':
return 'application/x-cdlink';

case 'pgn':
return 'application/x-chess-pgn';

case 'cpio':
return 'application/x-cpio';

case 'csh':
return 'application/x-csh';

case 'dcr':
case 'dir':
case 'dxr':
return 'application/x-director';

case 'dvi':
return 'application/x-dvi';

case 'spl':
return 'application/x-futuresplash';

case 'gtar':
return 'application/x-gtar';

case 'hdf':
return 'application/x-hdf';

case 'js':
return 'application/x-javascript';

case 'skp':
case 'skd':
case 'skt':
case 'skm':
return 'application/x-koan';

case 'latex':
return 'application/x-latex';

case 'nc':
case 'cdf':
return 'application/x-netcdf';

case 'sh':
return 'application/x-sh';

case 'shar':
return 'application/x-shar';

case 'swf':
return 'application/x-shockwave-flash';

case 'sit':
return 'application/x-stuffit';

case 'sv4cpio':
return 'application/x-sv4cpio';

case 'sv4crc':
return 'application/x-sv4crc';

case 'tar':
return 'application/x-tar';

case 'tcl':
return 'application/x-tcl';

case 'tex':
return 'application/x-tex';

case 'texinfo':
case 'texi':
return 'application/x-texinfo';

case 't':
case 'tr':
case 'troff':
return 'application/x-troff';

case 'man':
return 'application/x-troff-man';

case 'me':
return 'application/x-troff-me';

case 'ms':
return 'application/x-troff-ms';

case 'ustar':
return 'application/x-ustar';

case 'src':
return 'application/x-wais-source';

case 'zip':
return 'application/zip';

case 'au':
case 'snd':
return 'audio/basic';

case 'mid':
case 'midi':
case 'kar':
return 'audio/midi';

case 'mpga':
case 'mp2':
case 'mp3':
return 'audio/mpeg';

case 'aif':
case 'aiff':
case 'aifc':
return 'audio/x-aiff';

case 'm3u':
return 'audio/x-mpegurl';

case 'ram':
case 'rm':
return 'audio/x-pn-realaudio';

case 'rpm':
return 'audio/x-pn-realaudio-plugin';

case 'ra':
return 'audio/x-realaudio';

case 'wav':
return 'audio/x-wav';

case 'pdb':
return 'chemical/x-pdb';

case 'xyz':
return 'chemical/x-xyz';

case 'bmp':
return 'image/bmp';

case 'gif':
return 'image/gif';

case 'ief':
return 'image/ief';

case 'jpeg':
case 'jpg':
case 'jpe':
return 'image/jpeg';

case 'png':
return 'image/png';

case 'tiff':
case 'tif':
return 'image/tiff';

case 'wbmp':
return 'image/vnd.wap.wbmp';

case 'ras':
return 'image/x-cmu-raster';

case 'pnm':
return 'image/x-portable-anymap';

case 'pbm':
return 'image/x-portable-bitmap';

case 'pgm':
return 'image/x-portable-graymap';

case 'ppm':
return 'image/x-portable-pixmap';

case 'rgb':
return 'image/x-rgb';

case 'xbm':
return 'image/x-xbitmap';

case 'xpm':
return 'image/xpixmap';

case 'xwd':
return 'image/xwindowdump';

case 'igs':
case 'iges':
return 'model/iges';

case 'msh':
case 'mesh':
case 'silo':
return 'model/mesh';

case 'wrl':
case 'vrml':
return 'model/vrml';

case 'css':
return 'text/css';

case 'html':
case 'htm':
return 'text/html';

case 'asc':
case 'txt':
return 'text/plain';

case 'rtx':
return 'text/richtext';

case 'rtf':
return 'text/rtf';

case 'sgml':
case 'sgm':
return 'text/sgml';

case 'tsv':
return 'text/tab-seperated-values';

case 'wml':
return 'text/vnd.wap.wml';

case 'wmls':
return 'text/vnd.wap.wmlscript';

case 'etx':
return 'text/x-setext';

case 'xml':
case 'xsl':
return 'text/xml';

case 'mpeg':
case 'mpg':
case 'mpe':
return 'video/mpeg';

case 'qt':
case 'mov':
return 'video/quicktime';

case 'mxu':
return 'video/vnd.mpegurl';

case 'avi':
return 'video/x-msvideo';

case 'movie':
return 'video/x-sgi-movie';

case 'ice':
return 'x-conference/x-cooltalk';

default:
return 'application/unknown';
}
}
?>
