<?php

$mainGUI = &GUIFactory::setMainGUI( "main" );

$datasource_delete_error = false;
function cmd_source_delete( $id, $param ) {
global $W_DEL, $T_SOURCE, $datasource_delete_error;

//                                              
 $res = query("SELECT COUNT(*) c FROM construct c
		INNER JOIN part p ON p.construct_id = c.id
		WHERE p.type_id IN (29,30) AND p.info_int = " . sql_num($id));

if ($res["arr"][0]["c"] > 0) {
//                                     
 $datasource_delete_error = true;
} else {
//               
 $sql = "DELETE FROM datasource WHERE id = ".sqlf_tl_num($id);
query( $sql );//            
 $sql = "DELETE FROM datasource_value WHERE datasource_id = ".sqlf_tl_num($id);
query( $sql );//            
 
logcmd( $W_DEL, $T_SOURCE, $id, 0, "cmd_source_delete" );
triggerEvent($T_SOURCE, $id, EVENT_DELETE, new EventObject() );
}
}

class SourceTypeFormatter 
{
function format( $row )
{
return SourceFactory::getTypeName( $row["source_type"] );
}
}


//                        
$select = "id, name, source_type";
$from   = "datasource";
$where = "name != ''";
$ds = new SQLDatasource( "people", $select, $from, $where );//            
$ds->setDBHandle( $DB );
if ($FEATURE["datasource_perm"]) {
$ds->setSQLDatasourceFilter(new SQLDatasourcePermFilter());
}
$ds->addColumn( "lname", i18n("Name"), true, "name", "name");
$ds->addColumn( "ftype", i18n("Type"), true, false, "source_type" );
$ds->setDefaultSort("lname","ASC");
$ds->makeLink("lname","name", "do=19102", "list", "source_id", "id");
$ds->addFormatter( "ftype", new SourceTypeFormatter() );
//                                      
$ds->addAction( new CommandAction($ICO_DELETE, "del", i18n( "Delete" ), "cmd_source_delete" ) );

//           
$list = new ItemList3("sources",$ds);
$list->setShowInfo( true );

?>
