#
# Table structure for table 'faqcontent'
#
DROP TABLE IF EXISTS faqcontent;
CREATE TABLE faqcontent (
	id int(11) DEFAULT '0' NOT NULL auto_increment,
	name text,
	description text,
	maintext text,
	keywords text,
	url text,
	folder_id int(11),
	foldername varchar(255),
	PRIMARY KEY (id)
);

#
# Table structure for table 'faqinfo'
#
DROP TABLE IF EXISTS faqinfo;
CREATE TABLE faqinfo (
	faq_id int(11),
	visited int(11),
	time int(11)
);

#
# Table structure for table 'faqsearch'
#
DROP TABLE IF EXISTS faqsearch;
CREATE TABLE faqsearch (
	search varchar(255),
	counter int(11),
	timestamp int(11)
);

#
# Table structure for table 'faqvote'
#
DROP TABLE IF EXISTS faqvote;
CREATE TABLE faqvote (
	faq_id int(11),
	vote int(11),
	time int(11)
);
