<?
define( "WF_SCOPE_GLOBAL", 1 );
define( "WF_SCOPE_LOCAL", 2 ); 
class workflow_selector {

//                         
 //      
 var $wtype = "";

//               
 var $has_info = false;

//               
 var $winfo = array();

//                        
 var $value = "";
var $info  = "";

var $prefix = "";

var $full = false;

var $selector = "";
var $scope = WF_SCOPE_LOCAL;

//            
 function workflow_selector($wtype, $prefix, $info = false, $selectScope=WF_SCOPE_GLOBAL) {
global $W_TYPE;
$this->wtype = $wtype;

$this->has_info = $info;

$this->prefix = $prefix;

$this->winfo = get_wtype_info($wtype);

$this->scope = $selectScope;

if ($this->winfo["input"] == "selector") {
$finit = $this->winfo["init"];
$this->selector = $finit($prefix, $this->winfo, $selectScope);
}
}

//                                       
 function set_value($value, $info = "") {
$this->value = $value;
$this->info = $info;

$info = $this->winfo;
$prefix = $this->prefix;

if ($this->selector) {
$this->selector->set_value($value);
}

if ($info["input"] == "select" || $info["input"] == "text" || $info["input"] == "int") {
global ${$prefix."_val"};

${$prefix."_val"} = $value;
} else if ($info["input"] == "period") {
global ${$prefix."_days"};
$hours = floor($value/86400);
${$prefix."_days"} = $hours;
$val = $value%86400;

} else if ($info["input"] == "time") {
global ${$prefix."_date"},${$prefix."_time"};

${$prefix."_date"} = $value;
${$prefix."_time"} = $value;

} else if ($info["input"] == "check") {
global ${$prefix."_val"};

${$prefix."_val"} = ($value)?1:0;

} else if (!$this->full && $info["input"]) {
global ${$prefix."_val"}, ${$prefix."_text"};

${$prefix."_val"} = $value;
${$prefix."_text"} = $this->get_text();
}

if ($this->has_info) {
if ($info["type"] == "text") {
//                 /       /                              
 } else if ($info["type"] == "int") {
//                 /       /         
 } else if ($info["type"] == "tree") {
global ${$prefix."_rec"};
${$prefix."_rec"} = (strpos($this->info,":recursive"))?1:0;
} else if ($info["type"] == "period") {
global ${$prefix."_repeat"};
${$prefix."_repeat"} = (strpos($this->info,":repeat"))?1:0;
}
}
}

//                          
 function get_text($addinfo=false) {
$out = "";

$info = $this->winfo;
$val = $this->get_value();

if ($info["input"] == "check") {
$out .= ($val)?$DIC[121]:$DIC[122];
} else if ($info["input"] == "time") {
$out .= date("d.m.Y H:i",$val);
} else if ($info["input"] == "period") {
$days = floor($val/86400);
$out .= $DIC[1604].": ".$days." ".$DIC[1564];
$val = $val%86400;
$hours = floor($val/3600);
if ($val) {
$out .= " ".$hours." ".$DIC[1605];
$val = $val%3600;
$min = floor($val/60);
if ($val) {
$out .= " ".$min." ".$DIC[1606];
}
}
} else if ($info["input"] == "select") {
$out .= $info["values"][$val];
} else if ($info["input"] == "selector") {
$out .= $this->selector->get_text();
} else {
$out .= $val;
}

if ($this->has_info && $addinfo) {
$out .= ", ".$this->get_info();
}

return $out;
}

//                     
 function get_name() {
return ($this->winfo["name"])?$this->winfo["name"]:$this->wtype;
}

//                     
 function use_htmlform(&$hi, $full = false, $optional = true, $enabled = true, $hidden=false) {
global $HI, $DIC;

$prefix = $this->prefix;

$type = $this->wtype;
$info = $this->winfo;

$this->full = $full;

if ($info["input"] == "select") {
$f = $hidden?$HI["hidden"]:$HI["sel"];
$f["var"] = $prefix."_val";
$f["list"] = $info["values"];
$f["optional"] = $optional;
$f["disabled"] = !$enabled;
$f["force"] = false;
$hi[] = $f;
} else if ($info["input"] == "text") {
$f = $hidden?$HI["hidden"]:$HI["text"];
$f["var"] = $prefix."_val";
$f["optional"] = $optional;
$f["readonly"] = !$enabled;
$hi[] = $f;
} else if ($info["input"] == "int") {
$f = $hidden?$HI["hidden"]:$HI["text"];
$f["var"] = $prefix."_val";
$f["optional"] = $optional;
$f["readonly"] = !$enabled;
$hi[] = $f;
} else if ($info["input"] == "time") {
$f = $hidden?$HI["hidden"]:$HI["date"];
$f["var"] = $prefix."_date";
$f["optional"] = $optional;
$f["readonly"] = $readonly;
$f["label"] = $DIC[1194];
$hi[] = $f;

$f = $hidden?$HI["hidden"]:$HI["time"];
$f["var"] = $prefix."_time";
$f["optional"] = $optional;
$f["readonly"] = $readonly;
$f["label"] = $DIC[840];
$hi[] = $f;
} else if ($info["input"] == "period") {
$f = $hidden?$HI["hidden"]:$HI["int"];
$f["var"] = $prefix."_days";
$f["optional"] = $optional;
$f["readonly"] = $readonly;
$f["regex"] = "^[0-9]+$";
$f["regid"] = "";
$f["label"] = $DIC[1564];
$hi[] = $f;

} else if ($info["input"] == "check") {
$f = $hidden?$HI["hidden"]:$HI["checkbox"];
$f["var"] = $prefix."_val";
$f["value"] = "1";
$f["optional"] = $optional;
$f["readonly"] = $readonly;
$hi[] = $f;
} else if ($info["input"] == "selector" && $full) {
$this->selector->use_htmlform($hi,$full,$optional,$enabled,$hidden);
} else if (!$full && $info["input"]) {
$f = $HI["hidden"];
$f["var"] = $prefix."_val";
$hi[] = $f;
//                                 

$f = $hidden?$HI["hidden"]:$HI["text"];
$f["var"] = $prefix."_text";
$f["readonly"] = true;
$hi[] = $f;
}

if ($this->has_info) {
//                                 
 if ($info["type"] == "text") {

} else if ($info["type"] == "int") {

} else if ($info["type"] == "tree") {
$f = $hidden?$HI["hidden"]:$HI["checkbox"];
$f["var"] = $prefix."_rec";
$f["value"] = 1;
$f["optional"] = $optional;
$f["readonly"] = $readonly;
$f["label"] = $DIC[1607];
$hi[] = $f;
} else if ($info["type"] == "period") {

$f = $hidden?$HI["hidden"]:$HI["checkbox"];
$f["var"] = $prefix."_repeat";
$f["optional"] = $optional;
$f["readonly"] = $readonly;
$f["label"] = $DIC[2727];
$hi[] = $f;	
}
}
}

//                                                                         
 function get_selector(&$f,$jsform="gentics", $hidden=FALSE) {
global $STAG, $ICO_MINI;

$prefix = $this->prefix;
$type = $this->wtype;
$info = $this->winfo;
$full = $this->full;

$out = "";

$out .= "<table><tr valign=middle><td nowrap>";

if ($info["input"] == "select" || $info["input"] == "text" || $info["input"] == "int" || $info["input"] == "check") {
$out .= $f->e($prefix."_val");
} else if ($info["input"] == "time") {
$out .= $f->l($prefix."_date")."&nbsp".$f->e($prefix."_date")."&nbsp;&nbsp;".$f->l($prefix."_time").$f->e($prefix."_time");
} else if ($info["input"] == "period") {
$out .= "Alter: Tage ".$f->e($prefix."_days");

} else if ($info["input"] == "selector" && $full) {
$out .= $this->selector->get_selector($f, $jsform, $hidden);
} else if (!$full && $info["input"]) {
$out .= $f->e($prefix."_text")."</nobr>";
if ( !$hidden ) {
$out .= "<nobr><a href=\"#\" onclick=\"window.open('$STAG&do=708&type=$type&info=".(($this->has_info)?1:0)."&scope=".$this->scope."&val=".urlencode($this->get_value());
if ($this->hash_info) $out .= "&vinfo=".urlencode($this->get_info());
$out .= "&el=".($jsform.".f_".$this->prefix)."','select','scrollbars=yes, menubar=no, toolbar=no, width=500, height=500');return false;\">".img($ICO_MINI)."</a>";
}
}

$out .= "</td>";

if ($this->has_info) {
$out .= "<td nowrap>";

if ($info["type"] == "text") {

} else if ($info["type"] == "int") {

} else if ($info["type"] == "tree") {
$out .= $f->l($prefix."_rec")."&nbsp;".$f->e($prefix."_rec");
} else if ($info["type"] == "period") {
$out .= $f->l($prefix."_repeat")."&nbsp;".$f->e($prefix."_repeat");
}
$out .= "</td>";
}

$out .= "</tr></table>";

return $out;
}

//                                        
 function set_error(&$f) {
//                         
 }

//                                     
 function is_submitted() {
if (!$this->full) return true;

$info = $this->winfo;
$prefix = $this->prefix;

if ($info["input"] == "selector") {
return $this->selector->is_submitted();
}

return true;
}

//                
 function get_value() {
global $ICO_USER;

if ($this->is_submitted()) {
$info = $this->winfo;
$prefix = $this->prefix;
$full = $this->full;

if ($info["input"] == "select") {
global ${"f_".$prefix."_val"};
$this->value = ${"f_".$prefix."_val"};
} else if ($info["input"] == "time") {
global ${$prefix."_date"},${$prefix."_time"};
$t = ${$prefix."_time"};
$d = ${$prefix."_date"};
$this->value = mktime(date("H",$t),date("i",$t),0,date("m",$d),date("d",$d),date("Y",$d));
} else if ($info["input"] == "period") {
global ${$prefix."_days"},${$prefix."_hours"};
$d = ${$prefix."_days"};
$h = ${$prefix."_hours"};
$this->value = $d * 86400 + $h * 3600;
} else if ($info["input"] == "text" || $info["input"] == "check" || $info["input"] == "int" || ($info["input"] && !$full)) {
global ${$prefix."_val"};
$this->value = ${$prefix."_val"};
} else if ($info["input"] == "selector" && $full) {
$this->value = $this->selector->get_value();
}
}

return $this->value;
}

//                               
 function get_info() {
if (!$this->has_info) return "";

$info = $this->winfo;
$prefix = $this->prefix;

if ($info["type"] == "text") {
//                       
 global ${$prefix."_info"};
$this->info = ${$prefix."_info"}?${$prefix."_info"}:"match";
} else if ($info["type"] == "int") {
$this->info == "match";
} else if ($info["type"] == "time") {
$this->info = "time";
} else if ($info["type"] == "period") {
global ${$prefix."_repeat"};
$this->info = "period";
if (${$prefix."_repeat"}) $this->info .= ":repeat";
} else if ($info["type"] == "bool") {
$this->info = "match"; 
} else if ($info["type"] == "id") {
$this->info = "match";
} else if ($info["type"] == "tree") {
global ${$prefix."_rec"};
$this->info = "tree:";
if ($info["type_id"]) $this->info .= $info["type_id"];
if (${$prefix."_rec"}) $this->info .= ":recursive";
}

return $this->info;
}

}

?>
